ome-qtwidgets 5.3.2

Namespaces | Classes | Functions
ome::qtwidgets Namespace Reference

Qt5 widgets for image display with OpenGL. More...

## Namespaces
| gl
| OpenGL rendering.
| glsl
| OpenGL Shader Language (GLSL) program wrappers.

## Classes
class | GLContainer
| GL window container. More...
class | GLView2D
| 2D GL view of an image with axes and gridlines. More...
class | GLWindow
| Top level GL window. More...
class | NavigationDock2D
| 2D dock widget for plane nagivation. More...
struct | TexelProperties
| Map a given PixelType enum to the corresponding GL texel definitions. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::BIT >
| Properties of BIT texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::COMPLEXDOUBLE >
| Properties of DOUBLECOMPLEX texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::COMPLEXFLOAT >
| Properties of COMPLEX texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::DOUBLE >
| Properties of DOUBLE texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::FLOAT >
| Properties of FLOAT texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::INT16 >
| Properties of INT16 texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::INT32 >
| Properties of INT32 texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::INT8 >
| Properties of INT8 texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::UINT16 >
| Properties of UINT16 texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::UINT32 >
| Properties of UINT32 texels. More...
struct | TexelProperties< ::ome::xml::model::enums::PixelType::UINT8 >
| Properties of UINT8 texels. More...

## Functions
void | register_module_paths ()
| Register the OME-QtWidgets module paths with OME-Common. More...
GLenum | textureInternalFormat (::ome::xml::model::enums::PixelType pixeltype)
| Get the default internal (GL) pixel format of a PixelType. More...
GLenum | textureExternalFormat (::ome::xml::model::enums::PixelType pixeltype)
| Get the default external (GL) pixel format of a PixelType. More...
GLint | textureExternalType (::ome::xml::model::enums::PixelType pixeltype)
| Get the default external (GL) type of a PixelType. More...
::ome::xml::model::enums::PixelType | texturePixelTypeFallback (::ome::xml::model::enums::PixelType pixeltype)
| Get a fallback pixel type. More...
bool | textureConversionRequired (::ome::xml::model::enums::PixelType pixeltype)
| Check if type conversion is required. More...
bool | textureNormalizationRequired (::ome::xml::model::enums::PixelType pixeltype)
| Check if normalization is required. More...
GLint | textureMinificationFilter (::ome::xml::model::enums::PixelType pixeltype)
| Get the default minification filter. More...
GLint | textureMagnificationFilter (::ome::xml::model::enums::PixelType pixeltype)
| Get the default magnification filter. More...
GLenum | textureInternalFormatFallback (GLenum format)
| Get a fallback internal (GL) pixel format. More...

## Detailed Description

Qt5 widgets for image display with OpenGL.

## Function Documentation

## § register_module_paths()

void ome::qtwidgets::register_module_paths | ( |  | ) |

Register the OME-QtWidgets module paths with OME-Common.

This function forces path registration.

Note
  This is a hack to allow static linking to work on Windows; without this, the module object is omitted and the paths aren't automatically registered. This will no longer be required once it is built as a DLL. Its only purpose is to force object inclusion when static linking, and ensure that the registration happens independently of object static construction order to allow use prior to main() entry. You should not use this.

References register_module_paths(), ome::xml::register_module_paths(), and ome::common::register_module_paths().

## § textureConversionRequired()

bool ome::qtwidgets::textureConversionRequired | ( | ::ome::xml::model::enums::PixelType | pixeltype | ) |

Check if type conversion is required.

Conversion will be required if the GL type does not match the corresponding PixelType language type.

Parameters

  pixeltype | the PixelType to query.

Returns
  `true` if conversion is required, `false` otherwise.

## § textureExternalFormat()

GLenum ome::qtwidgets::textureExternalFormat | ( | ::ome::xml::model::enums::PixelType | pixeltype | ) |

Get the default external (GL) pixel format of a PixelType.

Parameters

  pixeltype | the PixelType to query.

Returns
  the GL external format.

## § textureExternalType()

GLint ome::qtwidgets::textureExternalType | ( | ::ome::xml::model::enums::PixelType | pixeltype | ) |

Get the default external (GL) type of a PixelType.

Parameters

  pixeltype | the PixelType to query.

Returns
  the GL external type.

## § textureInternalFormat()

GLenum ome::qtwidgets::textureInternalFormat | ( | ::ome::xml::model::enums::PixelType | pixeltype | ) |

Get the default internal (GL) pixel format of a PixelType.

Parameters

  pixeltype | the PixelType to query.

Returns
  the GL internal format.

## § textureInternalFormatFallback()

GLenum ome::qtwidgets::textureInternalFormatFallback | ( | GLenum | format | ) |

Get a fallback internal (GL) pixel format.

The fallback format will have the same channel count as the specified format, lower quality (smaller size) or different type (int rather than float).

Parameters

  format | the format which is not suitable.

Returns
  a downgraded format compared with the specified format.

## § textureMagnificationFilter()

GLint ome::qtwidgets::textureMagnificationFilter | ( | ::ome::xml::model::enums::PixelType | pixeltype | ) |

Get the default magnification filter.

Parameters

  pixeltype | the PixelType to query.

Returns
  the default magnification filter.

## § textureMinificationFilter()

GLint ome::qtwidgets::textureMinificationFilter | ( | ::ome::xml::model::enums::PixelType | pixeltype | ) |

Get the default minification filter.

Parameters

  pixeltype | the PixelType to query.

Returns
  the default minification filter.

## § textureNormalizationRequired()

bool ome::qtwidgets::textureNormalizationRequired | ( | ::ome::xml::model::enums::PixelType | pixeltype | ) |

Check if normalization is required.

Normalization will be required if the GL type is not automatically normalized. For example, this is usually automatic for integer types when using a floating point internal format, but will be required when using a floating point data, e.g. in a fragment shader, or before setting the texture.

Parameters

  pixeltype | the PixelType to query.

Returns
  `true` if normalization is required, `false` otherwise.

## § texturePixelTypeFallback()

ome::xml::model::enums::PixelType ome::qtwidgets::texturePixelTypeFallback | ( | ::ome::xml::model::enums::PixelType | pixeltype | ) |

Get a fallback pixel type.

The fallback format will have a lower quality (smaller size) or different type (int rather than float). If no fallback is available, the same type will be returned.

Parameters

  pixeltype | the PixelType to query.

Returns
  a downgraded PixelType.

References ome::xml::model::enums::PixelType::UINT8.